/**
 *  EAGLView.h
 *  Live2DSample
 *
 *  Copyright 2014 Live2D Inc. All rights reserved.
 */

#ifndef __EAGL_VIEW__
#define __EAGL_VIEW__


#import <UIKit/UIKit.h>
#import <QuartzCore/QuartzCore.h>
#import <OpenGLES/EAGL.h>
#import <OpenGLES/ES1/gl.h>
#import <OpenGLES/ES1/glext.h>
#import "Live2DModelIPhone.h"

@interface EAGLView : UIView
{    
@private
	
	live2d::Live2DModelIPhone* live2DModel ;
	EAGLContext *context;
	
	// The pixel dimensions of the CAEAGLLayer
	GLint deviceWidth, deviceHeight;
	
	// The OpenGL names for the framebuffer and renderbuffer used to render to this view
	GLuint defaultFramebuffer, colorRenderbuffer;
    NSMutableArray* textures;
}
- (id)initWithFrame:(CGRect)frame;
- (void) drawView:(id)sender;
- (void) dealloc;
- (GLuint)loadTexture:(NSString*)fileNamel;
@end


#endif
